// RAINBOND, Application Management Platform
// Copyright (C) 2014-2020 Goodrain Co., Ltd.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version. For any non-GPL usage of Rainbond,
// one or multiple Commercial Licenses authorized by Goodrain Co., Ltd.
// must be obtained first.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/goodrain/rainbond-operator/pkg/apis/rainbond/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeRainbondClusters implements RainbondClusterInterface
type FakeRainbondClusters struct {
	Fake *FakeRainbondV1alpha1
	ns   string
}

var rainbondclustersResource = schema.GroupVersionResource{Group: "rainbond.io", Version: "v1alpha1", Resource: "rainbondclusters"}

var rainbondclustersKind = schema.GroupVersionKind{Group: "rainbond.io", Version: "v1alpha1", Kind: "RainbondCluster"}

// Get takes name of the rainbondCluster, and returns the corresponding rainbondCluster object, and an error if there is any.
func (c *FakeRainbondClusters) Get(name string, options v1.GetOptions) (result *v1alpha1.RainbondCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(rainbondclustersResource, c.ns, name), &v1alpha1.RainbondCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.RainbondCluster), err
}

// List takes label and field selectors, and returns the list of RainbondClusters that match those selectors.
func (c *FakeRainbondClusters) List(opts v1.ListOptions) (result *v1alpha1.RainbondClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(rainbondclustersResource, rainbondclustersKind, c.ns, opts), &v1alpha1.RainbondClusterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.RainbondClusterList{ListMeta: obj.(*v1alpha1.RainbondClusterList).ListMeta}
	for _, item := range obj.(*v1alpha1.RainbondClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested rainbondClusters.
func (c *FakeRainbondClusters) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(rainbondclustersResource, c.ns, opts))

}

// Create takes the representation of a rainbondCluster and creates it.  Returns the server's representation of the rainbondCluster, and an error, if there is any.
func (c *FakeRainbondClusters) Create(rainbondCluster *v1alpha1.RainbondCluster) (result *v1alpha1.RainbondCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(rainbondclustersResource, c.ns, rainbondCluster), &v1alpha1.RainbondCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.RainbondCluster), err
}

// Update takes the representation of a rainbondCluster and updates it. Returns the server's representation of the rainbondCluster, and an error, if there is any.
func (c *FakeRainbondClusters) Update(rainbondCluster *v1alpha1.RainbondCluster) (result *v1alpha1.RainbondCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(rainbondclustersResource, c.ns, rainbondCluster), &v1alpha1.RainbondCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.RainbondCluster), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeRainbondClusters) UpdateStatus(rainbondCluster *v1alpha1.RainbondCluster) (*v1alpha1.RainbondCluster, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(rainbondclustersResource, "status", c.ns, rainbondCluster), &v1alpha1.RainbondCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.RainbondCluster), err
}

// Delete takes name of the rainbondCluster and deletes it. Returns an error if one occurs.
func (c *FakeRainbondClusters) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(rainbondclustersResource, c.ns, name), &v1alpha1.RainbondCluster{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRainbondClusters) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(rainbondclustersResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.RainbondClusterList{})
	return err
}

// Patch applies the patch and returns the patched rainbondCluster.
func (c *FakeRainbondClusters) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.RainbondCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(rainbondclustersResource, c.ns, name, pt, data, subresources...), &v1alpha1.RainbondCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.RainbondCluster), err
}
