// RAINBOND, Application Management Platform
// Copyright (C) 2014-2020 Goodrain Co., Ltd.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version. For any non-GPL usage of Rainbond,
// one or multiple Commercial Licenses authorized by Goodrain Co., Ltd.
// must be obtained first.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/goodrain/rainbond-operator/pkg/apis/rainbond/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// RbdComponentLister helps list RbdComponents.
type RbdComponentLister interface {
	// List lists all RbdComponents in the indexer.
	List(selector labels.Selector) (ret []*v1alpha1.RbdComponent, err error)
	// RbdComponents returns an object that can list and get RbdComponents.
	RbdComponents(namespace string) RbdComponentNamespaceLister
	RbdComponentListerExpansion
}

// rbdComponentLister implements the RbdComponentLister interface.
type rbdComponentLister struct {
	indexer cache.Indexer
}

// NewRbdComponentLister returns a new RbdComponentLister.
func NewRbdComponentLister(indexer cache.Indexer) RbdComponentLister {
	return &rbdComponentLister{indexer: indexer}
}

// List lists all RbdComponents in the indexer.
func (s *rbdComponentLister) List(selector labels.Selector) (ret []*v1alpha1.RbdComponent, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.RbdComponent))
	})
	return ret, err
}

// RbdComponents returns an object that can list and get RbdComponents.
func (s *rbdComponentLister) RbdComponents(namespace string) RbdComponentNamespaceLister {
	return rbdComponentNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// RbdComponentNamespaceLister helps list and get RbdComponents.
type RbdComponentNamespaceLister interface {
	// List lists all RbdComponents in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1alpha1.RbdComponent, err error)
	// Get retrieves the RbdComponent from the indexer for a given namespace and name.
	Get(name string) (*v1alpha1.RbdComponent, error)
	RbdComponentNamespaceListerExpansion
}

// rbdComponentNamespaceLister implements the RbdComponentNamespaceLister
// interface.
type rbdComponentNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all RbdComponents in the indexer for a given namespace.
func (s rbdComponentNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.RbdComponent, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.RbdComponent))
	})
	return ret, err
}

// Get retrieves the RbdComponent from the indexer for a given namespace and name.
func (s rbdComponentNamespaceLister) Get(name string) (*v1alpha1.RbdComponent, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("rbdcomponent"), name)
	}
	return obj.(*v1alpha1.RbdComponent), nil
}
